import { Programmer } from "./Programmer.js";

const Ivan = new Programmer('Ivan777', '25', '1000', 'Pascal');
const Molly = new Programmer('Molly', '32', '2000', 'PHP');
const Vitalii = new Programmer('Vitalii', '37', '3000', 'JS, Phyton');

console.log('Ivan', Ivan);
console.log('Molly', Molly);
console.log('Vitalii', Vitalii);

console.log('Ivan.salary:', Ivan.salary);
console.log('Molly.salary:', Molly.salary);
console.log('Vitalii.salary:', Vitalii.salary);


// 1. Поясніть своїми словами, як ви розумієте, як працює прототипне наслідування в Javascript

// Все объекты в JS имеют скрытое свойство Prototype в котором указаны все свойства и методы доступные родительскому глобальному объекту.
// Этот родительский объект является прототипом для остальных объектов. Таким образом объекты js,
// будучи наследниками тех или иных глобальных объектов таких как Array, String, Object... наследуют все свойства и методы своих прототипов - это прототипное наследование.
// Также в JS мы сами можем указывать объектам что, на пример, объект1 будет прототипом объекта2 ==> obj2.__proto__ = obj1.
// Теперь если мы захотим обратится к свойству или методу которых не будетв obj2 JS будет искать их в obj1.


// 2. Для чого потрібно викликати super() у конструкторі класу-нащадка?

// super() вызывается для того, чтобы получить доступ к родительскому конструктору внутри дочернего класса.
// Его нужно візівать в конструкторе дочернего класса, в самом начале, перед использованием ключевого слова this.
// Таким образом, объект созданный на основе дочернего класса получит все свойства, родительского класса.

